diff --git a/app/test/test_barrier.c b/app/test/test_barrier.c
index 43b5f6232c6d..1ef2b6e45228 100644
--- a/app/test/test_barrier.c
+++ b/app/test/test_barrier.c
@@ -66,7 +66,7 @@ struct plock_test {
 struct lcore_plock_test {
 	struct plock_test *pt[2]; /* shared, lock-protected data */
 	uint64_t sum[2];          /* local copy of the shared data */
-	uint64_t iter;            /* number of iterations to perfom */
+	uint64_t iter;            /* number of iterations to perform */
 	uint32_t lc;              /* given lcore id */
 };
 
diff --git a/app/test/test_func_reentrancy.c b/app/test/test_func_reentrancy.c
index 99ad902a2488..4767c0cfad9a 100644
--- a/app/test/test_func_reentrancy.c
+++ b/app/test/test_func_reentrancy.c
@@ -242,7 +242,7 @@ hash_create_free(__attribute__((unused)) void *arg)
 			rte_atomic32_inc(&obj_count);
 	}
 
-	/* create mutiple times simultaneously */
+	/* create multiple times simultaneously */
 	for (i = 0; i < MAX_ITER_MULTI; i++) {
 		snprintf(hash_name, sizeof(hash_name), "fr_test_%d_%d", lcore_self, i);
 		hash_params.name = hash_name;
@@ -306,7 +306,7 @@ fbk_create_free(__attribute__((unused)) void *arg)
 			rte_atomic32_inc(&obj_count);
 	}
 
-	/* create mutiple fbk tables simultaneously */
+	/* create multiple fbk tables simultaneously */
 	for (i = 0; i < MAX_ITER_MULTI; i++) {
 		snprintf(fbk_name, sizeof(fbk_name), "fr_test_%d_%d", lcore_self, i);
 		fbk_params.name = fbk_name;
@@ -368,7 +368,7 @@ lpm_create_free(__attribute__((unused)) void *arg)
 			rte_atomic32_inc(&obj_count);
 	}
 
-	/* create mutiple fbk tables simultaneously */
+	/* create multiple fbk tables simultaneously */
 	for (i = 0; i < MAX_LPM_ITER_TIMES; i++) {
 		snprintf(lpm_name, sizeof(lpm_name), "fr_test_%d_%d", lcore_self, i);
 		lpm = rte_lpm_create(lpm_name, SOCKET_ID_ANY, &config);
diff --git a/app/test/test_ipsec.c b/app/test/test_ipsec.c
index 83f789508fe5..f3792c2ade23 100644
--- a/app/test/test_ipsec.c
+++ b/app/test/test_ipsec.c
@@ -650,7 +650,7 @@ create_crypto_session(struct ipsec_unitest_params *ut,
 	if (s == NULL)
 		return -ENOMEM;
 
-	/* initiliaze SA crypto session for device */
+	/* initialaze SA crypto session for device */
 	rc = rte_cryptodev_sym_session_init(dev_id, s,
 			ut->crypto_xforms, qp->mp_session_private);
 	if (rc == 0) {
diff --git a/app/test/test_kni.c b/app/test/test_kni.c
index 7a65de179b17..6ea8df675e6b 100644
--- a/app/test/test_kni.c
+++ b/app/test/test_kni.c
@@ -556,7 +556,7 @@ test_kni(void)
 	}
 	closedir(dir);
 
-	/* Initialize KNI subsytem */
+	/* Initialize KNI subsystem */
 	rte_kni_init(KNI_TEST_MAX_PORTS);
 
 	if (test_kni_allocate_lcores() < 0) {
diff --git a/app/test/test_link_bonding.c b/app/test/test_link_bonding.c
index 938fafca3a95..754dede86e27 100644
--- a/app/test/test_link_bonding.c
+++ b/app/test/test_link_bonding.c
@@ -2920,7 +2920,7 @@ test_balance_tx_burst_slave_tx_fail(void)
 	first_tx_fail_idx = TEST_BAL_SLAVE_TX_FAIL_BURST_SIZE_1 -
 			TEST_BAL_SLAVE_TX_FAIL_PACKETS_COUNT;
 
-	/* copy mbuf referneces for expected transmission failures */
+	/* copy mbuf references for expected transmission failures */
 	for (i = 0; i < TEST_BAL_SLAVE_TX_FAIL_PACKETS_COUNT; i++)
 		expected_fail_pkts[i] = pkts_burst_1[i + first_tx_fail_idx];
 
diff --git a/app/test/test_lpm.c b/app/test/test_lpm.c
index e969fe05100c..88a12fba3454 100644
--- a/app/test/test_lpm.c
+++ b/app/test/test_lpm.c
@@ -173,7 +173,7 @@ test3(void)
 	status = rte_lpm_add(NULL, ip, depth, next_hop);
 	TEST_LPM_ASSERT(status < 0);
 
-	/*Create vaild lpm to use in rest of test. */
+	/*Create valid lpm to use in rest of test. */
 	lpm = rte_lpm_create(__func__, SOCKET_ID_ANY, &config);
 	TEST_LPM_ASSERT(lpm != NULL);
 
@@ -211,7 +211,7 @@ test4(void)
 	status = rte_lpm_delete(NULL, ip, depth);
 	TEST_LPM_ASSERT(status < 0);
 
-	/*Create vaild lpm to use in rest of test. */
+	/*Create valid lpm to use in rest of test. */
 	lpm = rte_lpm_create(__func__, SOCKET_ID_ANY, &config);
 	TEST_LPM_ASSERT(lpm != NULL);
 
@@ -249,7 +249,7 @@ test5(void)
 	status = rte_lpm_lookup(NULL, ip, &next_hop_return);
 	TEST_LPM_ASSERT(status < 0);
 
-	/*Create vaild lpm to use in rest of test. */
+	/*Create valid lpm to use in rest of test. */
 	lpm = rte_lpm_create(__func__, SOCKET_ID_ANY, &config);
 	TEST_LPM_ASSERT(lpm != NULL);
 
diff --git a/app/test/test_lpm6.c b/app/test/test_lpm6.c
index 670aadb40eb3..1b788386a083 100644
--- a/app/test/test_lpm6.c
+++ b/app/test/test_lpm6.c
@@ -262,7 +262,7 @@ test4(void)
 	status = rte_lpm6_add(NULL, ip, depth, next_hop);
 	TEST_LPM_ASSERT(status < 0);
 
-	/*Create vaild lpm to use in rest of test. */
+	/*Create valid lpm to use in rest of test. */
 	lpm = rte_lpm6_create(__func__, SOCKET_ID_ANY, &config);
 	TEST_LPM_ASSERT(lpm != NULL);
 
@@ -300,7 +300,7 @@ test5(void)
 	status = rte_lpm6_delete(NULL, ip, depth);
 	TEST_LPM_ASSERT(status < 0);
 
-	/*Create vaild lpm to use in rest of test. */
+	/*Create valid lpm to use in rest of test. */
 	lpm = rte_lpm6_create(__func__, SOCKET_ID_ANY, &config);
 	TEST_LPM_ASSERT(lpm != NULL);
 
@@ -338,7 +338,7 @@ test6(void)
 	status = rte_lpm6_lookup(NULL, ip, &next_hop_return);
 	TEST_LPM_ASSERT(status < 0);
 
-	/*Create vaild lpm to use in rest of test. */
+	/*Create valid lpm to use in rest of test. */
 	lpm = rte_lpm6_create(__func__, SOCKET_ID_ANY, &config);
 	TEST_LPM_ASSERT(lpm != NULL);
 
@@ -376,7 +376,7 @@ test7(void)
 	status = rte_lpm6_lookup_bulk_func(NULL, ip, next_hop_return, 10);
 	TEST_LPM_ASSERT(status < 0);
 
-	/*Create vaild lpm to use in rest of test. */
+	/*Create valid lpm to use in rest of test. */
 	lpm = rte_lpm6_create(__func__, SOCKET_ID_ANY, &config);
 	TEST_LPM_ASSERT(lpm != NULL);
 
@@ -414,7 +414,7 @@ test8(void)
 	status = rte_lpm6_delete_bulk_func(NULL, ip, depth, 10);
 	TEST_LPM_ASSERT(status < 0);
 
-	/*Create vaild lpm to use in rest of test. */
+	/*Create valid lpm to use in rest of test. */
 	lpm = rte_lpm6_create(__func__, SOCKET_ID_ANY, &config);
 	TEST_LPM_ASSERT(lpm != NULL);
 
@@ -434,7 +434,7 @@ test8(void)
 /*
  * Call add, lookup and delete for a single rule with depth < 24.
  * Check all the combinations for the first three bytes that result in a hit.
- * Delete the rule and check that the same test returs a miss.
+ * Delete the rule and check that the same test returns a miss.
  */
 int32_t
 test9(void)
@@ -1739,7 +1739,7 @@ test27(void)
  * Call add, lookup and delete for a single rule with maximum 21bit next_hop
  * size.
  * Check that next_hop returned from lookup is equal to provisioned value.
- * Delete the rule and check that the same test returs a miss.
+ * Delete the rule and check that the same test returns a miss.
  */
 int32_t
 test28(void)
diff --git a/app/test/test_mbuf.c b/app/test/test_mbuf.c
index 2a97afe2044a..b81ebe346b55 100644
--- a/app/test/test_mbuf.c
+++ b/app/test/test_mbuf.c
@@ -803,7 +803,7 @@ test_refcnt_mbuf(void)
 		tref += refcnt_lcore[slave];
 
 	if (tref != refcnt_lcore[master])
-		rte_panic("refernced mbufs: %u, freed mbufs: %u\n",
+		rte_panic("referenced mbufs: %u, freed mbufs: %u\n",
 		          tref, refcnt_lcore[master]);
 
 	rte_mempool_dump(stdout, refcnt_pool);
diff --git a/app/test/test_mempool.c b/app/test/test_mempool.c
index 7738c73dbe72..b45b627b3fb2 100644
--- a/app/test/test_mempool.c
+++ b/app/test/test_mempool.c
@@ -561,7 +561,7 @@ test_mempool(void)
 	if (test_mempool_basic_ex(mp_nocache) < 0)
 		goto err;
 
-	/* mempool operation test based on single producer and single comsumer */
+	/* mempool operation test based on single producer and single consumer */
 	if (test_mempool_sp_sc() < 0)
 		goto err;
 
diff --git a/app/test/test_mempool_perf.c b/app/test/test_mempool_perf.c
index 4c877834e7b8..2586c69a8ec4 100644
--- a/app/test/test_mempool_perf.c
+++ b/app/test/test_mempool_perf.c
@@ -89,7 +89,7 @@ static rte_atomic32_t synchro;
 static unsigned n_get_bulk;
 static unsigned n_put_bulk;
 
-/* number of objects retrived from mempool before putting them back */
+/* number of objects retrieved from mempool before putting them back */
 static unsigned n_keep;
 
 /* number of enqueues / dequeues */
diff --git a/app/test/test_meter.c b/app/test/test_meter.c
index f6fe6494ab63..15d5a4839b4b 100644
--- a/app/test/test_meter.c
+++ b/app/test/test_meter.c
@@ -444,7 +444,7 @@ tm_test_srtcm_color_aware_check(void)
 	  * if using blind check
 	  */
 
-	/* previouly have a green, test points should keep unchanged */
+	/* previously have a green, test points should keep unchanged */
 	in[0] = in[1] = in[2] = in[3] = RTE_COLOR_GREEN;
 	out[0] = RTE_COLOR_GREEN;
 	out[1] = RTE_COLOR_YELLOW;
@@ -551,7 +551,7 @@ tm_test_trtcm_color_aware_check(void)
 	  * if using blind check
 	  */
 
-	/* previouly have a green, test points should keep unchanged */
+	/* previously have a green, test points should keep unchanged */
 	in[0] = in[1] = in[2] = in[3] = RTE_COLOR_GREEN;
 	out[0] = RTE_COLOR_GREEN;
 	out[1] = RTE_COLOR_YELLOW;
@@ -648,7 +648,7 @@ tm_test_trtcm_rfc4115_color_aware_check(void)
 	  * if using blind check
 	  */
 
-	/* previouly have a green, test points should keep unchanged */
+	/* previously have a green, test points should keep unchanged */
 	in[0] = in[1] = in[2] = in[3] = RTE_COLOR_GREEN;
 	out[0] = RTE_COLOR_GREEN;
 	out[1] = RTE_COLOR_YELLOW;
diff --git a/app/test/test_pmd_perf.c b/app/test/test_pmd_perf.c
index 4f9fc0d876f7..2b33bdd7f5ad 100644
--- a/app/test/test_pmd_perf.c
+++ b/app/test/test_pmd_perf.c
@@ -744,7 +744,7 @@ test_pmd_perf(void)
 				"rte_eth_dev_start: err=%d, port=%d\n",
 				ret, portid);
 
-		/* always eanble promiscuous */
+		/* always enable promiscuous */
 		rte_eth_promiscuous_enable(portid);
 
 		lcore_conf[slave_id].portlist[num++] = portid;
diff --git a/app/test/test_ring.c b/app/test/test_ring.c
index aaf1e70ad841..7f60857dc7e4 100644
--- a/app/test/test_ring.c
+++ b/app/test/test_ring.c
@@ -655,7 +655,7 @@ test_lookup_null(void)
 	struct rte_ring *rlp = rte_ring_lookup("ring_not_found");
 	if (rlp ==NULL)
 	if (rte_errno != ENOENT){
-		printf( "test failed to returnn error on null pointer\n");
+		printf("test failed to return error on null pointer\n");
 		return -1;
 	}
 	return 0;
diff --git a/app/test/test_rwlock.c b/app/test/test_rwlock.c
index 40f91759c269..2f4ff1d27462 100644
--- a/app/test/test_rwlock.c
+++ b/app/test/test_rwlock.c
@@ -461,7 +461,7 @@ try_rwlock_test_rda(void)
 {
 	try_test_reset();
 
-	/* start read test on all avaialble lcores */
+	/* start read test on all available lcores */
 	rte_eal_mp_remote_launch(try_read_lcore, NULL, CALL_MASTER);
 	rte_eal_mp_wait_lcore();
 